/* rng.c */
/*
Funksjonar som handterar kall som programmet mitt utfrer mot ein RNG.
Er no satt opp mot Mersenne Twister generatoren. (mt19937ar.c)
*/

#include "bonehShaw.h"

void seedRNG(void)
{
  init_genrand((unsigned)time(NULL));
}

/* Generates a 32 bit number in the range [0..q-1]*/
word getRandomWord(word q)
{
  return (genrand_real2() * q);
}

/* Generates a random 64 bit number */
dword getRandomDWord(void)
{
  dword x;

  /* Generate two 32 bit numbers. Concatenate to one 64 bit */
  x = ((dword)genrand_int32() << 32) + (dword)genrand_int32();
  return x;
}
